Package org.eclipse.viatra.query.patternlanguage.emf.types

## Class TypeInformation

- java.lang.Object
- - org.eclipse.viatra.query.patternlanguage.emf.types.TypeInformation

-     public class TypeInformation
      extends java.lang.Object

  This class is used to store type information for selected patterns
  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TypeInformation​(ITypeSystem typeSystem)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `declareType​(Expression expression, IInputKey type)` | Describes that the selected expression is declared to have the selected type
    `java.util.Set<IInputKey>` | `getAllPossibleParameterTypes​(Variable parameter)` |
    `java.util.Set<IInputKey>` | `getAllTypes​(Expression expression)` |
    `IInputKey` | `getType​(Expression expression)` |
    `boolean` | `isProcessed​(Pattern pattern)` |
    `void` | `provideType​(org.eclipse.viatra.query.patternlanguage.emf.types.judgements.AbstractTypeJudgement constraint)` | Describes that a constraint ensures that a variable has a specific type
    `void` | `setProcessed​(Pattern pattern)` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### TypeInformation

          public TypeInformation​(ITypeSystem typeSystem)

  - ### Method Detail

    - #### isProcessed

          public boolean isProcessed​(Pattern pattern)

    - #### setProcessed

          public void setProcessed​(Pattern pattern)

    - #### declareType

          public void declareType​(Expression expression,
                                  IInputKey type)

      Describes that the selected expression is declared to have the selected type
      Parameters:
        `expression` -
        `type` -

    - #### provideType

          public void provideType​(org.eclipse.viatra.query.patternlanguage.emf.types.judgements.AbstractTypeJudgement constraint)

      Describes that a constraint ensures that a variable has a specific type
      Parameters:
        `constraint` -

    - #### getType

          public IInputKey getType​(Expression expression)

    - #### getAllTypes

          public java.util.Set<IInputKey> getAllTypes​(Expression expression)

    - #### getAllPossibleParameterTypes

          public java.util.Set<IInputKey> getAllPossibleParameterTypes​(Variable parameter)

      Since:
        1.4

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`